import { router } from './modules/router.ts';

import './test/index.ts';
import './admin/index.ts';


type Message = {
  path: string;
  key?: string;
};

export const handleMessage = async function (m: Message) {
  console.log('message', m);

  const res = await router.parse(m);
  const { code, body, message } = res;
  console.log('response', res);
  return { code, data: body, message };
};
