import { useConfig } from '@abearxiong/use-config';
import { handleMessage } from './route.ts';
import { server as routerServer } from './modules/router.ts';
import http from 'http';

const config = useConfig();
routerServer.setHandle(handleMessage);

const server = http.createServer(routerServer.callback());

server.listen(config.port, () => {
  console.log(`Server running at http://localhost:${config.port}/`);
});
